package com.rjconsultores.ventaboletos.relatorios.impl;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;

import com.rjconsultores.ventaboletos.relatorios.utilitarios.ArrayDataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

public class RelatorioAidfDetalhado extends Relatorio {

	public RelatorioAidfDetalhado(Map<String, Object> parametros, Connection conexao) throws Exception
	{
		super(parametros, conexao);

		this.setCustomDataSource(new ArrayDataSource(this) {

			public void initDados() throws Exception {
				Connection conexao = this.relatorio.getConexao();
				Map<String, Object> parametros = this.relatorio.getParametros();
				String sql = getSql();
				
				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql);

				ResultSet rset = stmt.executeQuery();

				while (rset.next()) {
					Map<String, Object> dataResult = new HashMap<String, Object>();
					dataResult.put("aidf", rset.getString("aidf"));
					dataResult.put("empresa", rset.getString("nombempresa"));
					dataResult.put("estacao", rset.getString("estacao"));
					dataResult.put("agencia", rset.getString("nombpuntoventa"));
					dataResult.put("serie", rset.getString("serie"));
					dataResult.put("subserie", rset.getString("subserie"));
					dataResult.put("numeracao", rset.getString("numeracao"));
					dataResult.put("folios", rset.getString("folios"));
					dataResult.put("forminicio", rset.getString("forminicial"));
					dataResult.put("formfinal", rset.getString("formfinal"));
					this.dados.add(dataResult);
				}

				this.resultSet = rset;
			}
		});
	}

	@Override
	protected void processaParametros() throws Exception {
	}

	private String getSql() {
		StringBuilder sql = new StringBuilder();			
		sql.append(" select a.aidf_id as aidf, e.nombempresa, p.nombpuntoventa, a.serie, ab.estacion_id as estacao, a.subserie, a.forminicial, a.formfinal,");
		sql.append(" concat(a.forminicial, concat('-',a.formfinal)) as numeracao,");
		sql.append(" concat(fp.foliopreimpreso,concat('-',dab.numfoliofinal)) as folios ");
		sql.append(" from aidf a ");
		sql.append(" inner join empresa e on e.empresa_id = a.empresa_id ");
		sql.append(" inner join abasto_boleto ab on a.empresa_id = ab.empresa_id and ab.ACTIVO = 1  ");
		sql.append(" inner join det_abasto_boleto dab on dab.abastoboleto_id = ab.abastoboleto_id and dab.ACTIVO = 1 ");
		sql.append(" inner join punto_venta p on p.puntoventa_id = ab.puntoventa_id and p.ACTIVO = 1");
		sql.append(" inner join folio_preimpreso fp on (a.serie=fp.numeserie or concat(a.aidf_id, concat(a.serie,a.subserie))=fp.numeserie OR concat(a.serie,concat('-',a.subserie))=fp.numeserie) and fp.ACTIVO = 1");
		sql.append(" where ");
		sql.append(" a.ACTIVO = 1");
		if(parametros.get("EMPRESA_ID") != null){
			sql.append(" and a.empresa_id = ").append(parametros.get("EMPRESA_ID"));
		}			
		if(parametros.get("SERIE") != null){
			sql.append(" and (a.serie ='").append(parametros.get("SERIE")).append("'");
			sql.append(" or concat(a.aidf_id, concat(a.SERIE,a.SUBSERIE))='").append(parametros.get("SERIE")).append("')");
		}	
		if(parametros.get("AIDF") != null){
			sql.append(" and a.aidf_id like'%").append(parametros.get("AIDF")).append("%'");
		}	
		if(parametros.get("INICIOFORM") != null){
			sql.append(" and a.forminicial >= ").append(parametros.get("INICIOFORM"));
		}
		if(parametros.get("FIMFORM") != null){
			sql.append(" and a.formfinal <= ").append(parametros.get("FIMFORM"));
		}	
		if(parametros.get("NUMPUNTOVENTA") != null){
			sql.append(" and ab.puntoventa_id in(").append(parametros.get("NUMPUNTOVENTA")).append(") ");
		}	
		sql.append(" group by a.aidf_id, e.nombempresa, p.nombpuntoventa, a.serie, ab.estacion_id , a.subserie,concat(a.forminicial, concat('-',a.formfinal)), a.forminicial, a.formfinal, ");
		sql.append(" concat(fp.foliopreimpreso,concat('-',dab.numfoliofinal)) ");
		sql.append(" order by  a.aidf_id");
		
		return sql.toString();
				
		
	}

}
