package com.rjconsultores.ventaboletos.web.gui.controladores.pricing;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import org.apache.log4j.Logger;
import org.hibernate.Hibernate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

import com.rjconsultores.ventaboletos.entidad.PricingEspecifico;
import com.rjconsultores.ventaboletos.entidad.PricingEspecificoCanalVendas;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.PricingEspecificoCanalVendasService;
import com.rjconsultores.ventaboletos.service.PricingEspecificoService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("editarPricingEspecificoCanalVendasController")
@Scope("prototype")
public class EditarPricingEspecificoCanalVendasController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarPricingEspecificoCanalVendasController.class);

	private PricingEspecifico pricingEspecifico;
	private PricingEspecificoCanalVendas pricingEspecificoCanal;
	private MyListbox pricingListEspCanalVenda;
	private List<PricingEspecificoCanalVendas> lspricingCanal;
	private List<TipoPuntoVenta> lsPtovata;
	
	public List<TipoPuntoVenta> getLsPtovata() {
		return lsPtovata;
	}

	public void setLsPtovata(List<TipoPuntoVenta> lsPtovata) {
		this.lsPtovata = lsPtovata;
	}
	@Autowired
	private PricingEspecificoService pricingEspecificoService;
	@Autowired
	private TipoPuntoVentaService puntoVentaService;
    
	private Combobox cmbPtovta;
	
	@Autowired
	private PricingEspecificoCanalVendasService pricingEspecificoCanalService;
	
	private Boolean isEdicao;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsPtovata = puntoVentaService.obtenerTodos();
		pricingEspecifico = (PricingEspecifico) Executions.getCurrent().getArg().get("pricingEspecifico");
		if(pricingEspecifico.getPricingespecificoId() != null){
			pricingEspecifico = pricingEspecificoService.obtenerID(pricingEspecifico.getPricingespecificoId());
			lspricingCanal =  pricingEspecifico.getPricingEspecificoCanalVendasList();
			
		}
		
		pricingEspecificoCanal = (PricingEspecificoCanalVendas) Executions.getCurrent().getArg().get("pricingEspecificoCanal");
		pricingListEspCanalVenda = (MyListbox) Executions.getCurrent().getArg().get("pricingListEspCanal");
		isEdicao = (Boolean) Executions.getCurrent().getArg().get("isEdicao");
	    
		
		super.doAfterCompose(comp);
		Locale locale = new Locale("pt", "BR");
	

	}

	public void onClick$btnAdicionarPricingEspCanal(Event ev) throws Exception {
		PricingEspecificoCanalVendas pricingCanal  = new PricingEspecificoCanalVendas((TipoPuntoVenta)cmbPtovta.getSelectedItem().getValue(), pricingEspecifico, UsuarioLogado.getUsuarioLogado().getUsuarioId());

		List<PricingEspecificoCanalVendas> peoList = null;
		if (lspricingCanal == null || lspricingCanal.isEmpty()) {
			peoList = new ArrayList<PricingEspecificoCanalVendas>();
		} else {
			peoList = pricingEspecifico.getPricingEspecificoCanalVendasList();
		}
		Hibernate.initialize(pricingEspecifico);
		Hibernate.initialize(pricingEspecificoCanal);
		
		if (pricingEspecificoCanal.getPricingEspecificoCanalId() != null && peoList.contains(pricingCanal)) {
			int index = peoList.indexOf(pricingCanal);
			if(index >= 0) {
				peoList.set(index, pricingCanal);
			}
		} else {
			peoList.add(pricingCanal);
		}
		if (pricingEspecifico != null && pricingEspecifico.getPricingespecificoId() != null) {
			pricingEspecifico = pricingEspecificoService.obtenerID(pricingEspecifico.getPricingespecificoId().longValue());
		}
		
		pricingEspecificoCanal.setActivo(Boolean.TRUE);
		pricingEspecifico.setPricingEspecificoCanalVendasList(peoList);
		pricingListEspCanalVenda.addItemNovo(pricingCanal);
		if(pricingListEspCanalVenda.getSize()>1){
			TipoPuntoVenta tpv = puntoVentaService.obtenerID(new Short("-1"));
			PricingEspecificoCanalVendas pecv = new PricingEspecificoCanalVendas();
			pecv.setTipoPtovta(tpv);
			pecv.setActivo(Boolean.TRUE);
			pecv.setPricingEspecifico(pricingEspecifico);
			pricingListEspCanalVenda.removeItem(pecv);
		}
		
		closeWindow();
	}
	public void onClick$btnApagarPricingEspCanal(Event ev) throws Exception {
		PricingEspecificoCanalVendas pricingCanal  = new PricingEspecificoCanalVendas((TipoPuntoVenta)cmbPtovta.getSelectedItem().getValue(), pricingEspecifico, UsuarioLogado.getUsuarioLogado().getUsuarioId());

		List<PricingEspecificoCanalVendas> peoList = null;
		if (lspricingCanal == null || lspricingCanal.isEmpty()) {
			peoList = new ArrayList<PricingEspecificoCanalVendas>();
		} else {
			peoList = pricingEspecifico.getPricingEspecificoCanalVendasList();
		}
		Hibernate.initialize(pricingEspecifico);
		Hibernate.initialize(pricingEspecificoCanal);
		
		if (pricingEspecificoCanal.getPricingEspecificoCanalId() != null && peoList.contains(pricingCanal)) {
			int index = peoList.indexOf(pricingCanal);
			if(index >= 0) {
				peoList.set(index, pricingCanal);
			}
		} else {
			peoList.add(pricingCanal);
		}
		if (pricingEspecifico != null && pricingEspecifico.getPricingespecificoId() != null) {
			pricingEspecifico = pricingEspecificoService.obtenerID(pricingEspecifico.getPricingespecificoId().longValue());
		}
		
		pricingEspecificoCanal.setActivo(Boolean.TRUE);
		pricingEspecifico.setPricingEspecificoCanalVendasList(peoList);
		pricingListEspCanalVenda.addItemNovo(pricingCanal);
		closeWindow();
	}

	public PricingEspecifico getPricingEspecifico() {
		return pricingEspecifico;
	}

	public void setPricingEspecifico(PricingEspecifico pricingEspecifico) {
		this.pricingEspecifico = pricingEspecifico;
	}

	public Combobox getCmbPtovta() {
		return cmbPtovta;
	}

	public void setCmbPtovta(Combobox cmbPtovta) {
		this.cmbPtovta = cmbPtovta;
	}
	
	

}
